# -*- coding: utf-8 -*-
"""
Created on Tue Apr 26 12:36:57 2016

@author: kswider
"""
   
# Kolejną strukturą danych jest zbior będący kolekcją unikalnych elementow
   
zbior = set()
zbior.add(1)        # zbior jest teraz { 1 }
zbior.add(2)        # zbior jest teraz { 1, 2 }
zbior.add(2)        # zbior jest nadal { 1, 2 }
x = len(zbior)      # podstawia 2
y = 2 in zbior      # podstawia True
z = 3 in zbior      # podstawia False

# Zbiory są stosowane z dwch ważnych powodow. Pierwszym jest t, że operacja 
# in działa ana zbiorach bardzo szybko. Jeśli mamy bardzo dużą kolekcję pozycji
# w ktorej bedzie sprawdzana przynależność, wtedy lepiej użyć zbioru niż listy.

stop_lista = ["a","an","at"] + setki_innych_slow + ["yet", "you"]

"zip" in stop_lista             # False, ale musi być sprawdzony każdy element

stop_lista_jako_zbior = set(stop_lista)
"zip" in stop_lista_jako_zbiort          # sprawdzanie jest bardzo szybkie

# Drugim powodem jest potrzeba wyszukania unikalnych pozycji w kolekcjach

lista_pozycji = [1, 2, 3, 1, 2, 3]
liczba_pozycji = len(lista_pozycji)              # 6
zbior_pozycji = set(lista_pozycji)               # {1, 2, 3}
liczba_roznych_pozycji = len(zbior_pozycji)      # 3
lista_roznych_pozycji = list(zbior_pozycji)      # [1, 2, 3]

# Na ogoł zbiory są stosowane znacznie rzadziej niż słowniki i listy.